Index: tests/raii/.expect/ctor-autogen-ERR1.nast.txt
===================================================================
--- tests/raii/.expect/ctor-autogen-ERR1.nast.txt	(revision 191702d26a35ef79ee328b6ec95287dbd7780cf1)
+++ tests/raii/.expect/ctor-autogen-ERR1.nast.txt	(revision 191702d26a35ef79ee328b6ec95287dbd7780cf1)
@@ -0,0 +1,53 @@
+raii/ctor-autogen.cfa:102:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: static inline function
+      ... with parameters
+        reference to instance of struct Managed with body
+        signed int
+      ... returning nothing
+
+      ... deleted by: ?{}: function
+      ... with parameters
+        reference to instance of struct Managed with body
+      ... returning nothing
+ with body
+        Compound Statement:
+          Expression Statement:
+            Application of
+              Variable Expression: ?=?: function
+              ... with parameters
+                reference to signed int
+                signed int
+              ... returning
+                signed int
+
+              ... to arguments
+              Generated Cast of:
+                Member Expression, with field:
+                  x: signed int
+                ... from aggregate:
+                  Generated Cast of:
+                    Variable Expression: m: reference to instance of struct Managed with body
+                  ... to:
+                    instance of struct Managed with body
+              ... to:
+                reference to signed int
+              Generated Cast of:
+                Constant Expression (0: zero_t)
+              ... to:
+                signed int
+
+            ... with environment:
+              Types:
+              Non-types:
+
+
+    ... to arguments
+    Generated Cast of:
+      Variable Expression: x: instance of struct Managed with body
+    ... to:
+      reference to instance of struct Managed with body
+    Constant Expression (123: signed int)
+
+... to: nothing
Index: tests/raii/.expect/ctor-autogen-ERR1.oast.txt
===================================================================
--- tests/raii/.expect/ctor-autogen-ERR1.oast.txt	(revision 191702d26a35ef79ee328b6ec95287dbd7780cf1)
+++ tests/raii/.expect/ctor-autogen-ERR1.oast.txt	(revision 191702d26a35ef79ee328b6ec95287dbd7780cf1)
@@ -0,0 +1,56 @@
+raii/ctor-autogen.cfa:102:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: static inline function
+      ... with parameters
+        _dst: reference to instance of struct Managed with body 1
+        x: signed int
+      ... returning nothing
+
+      ... deleted by: ?{}: function
+      ... with parameters
+        m: reference to instance of struct Managed with body 1
+      ... returning nothing
+      ... with body
+        CompoundStmt
+          Expression Statement:
+            Application of
+              Variable Expression: ?=?: function
+              ... with parameters
+                intrinsic reference to signed int
+                intrinsic signed int
+              ... returning
+                _retval__operator_assign: signed int
+                ... with attributes:
+                  Attribute with name: unused
+
+
+            ... to arguments
+              Generated Cast of:
+                Member Expression, with field:
+                  x: signed int
+                ... from aggregate:
+                  Generated Cast of:
+                    Variable Expression: m: reference to instance of struct Managed with body 1
+                  ... to:
+                    instance of struct Managed with body 1
+              ... to:
+                reference to signed int
+              Generated Cast of:
+                constant expression (0 0: zero_t)
+              ... to:
+                signed int
+
+            ... with environment:
+              Types:
+              Non-types:
+
+
+  ... to arguments
+    Generated Cast of:
+      Variable Expression: x: instance of struct Managed with body 1
+    ... to:
+      reference to instance of struct Managed with body 1
+    constant expression (123 123: signed int)
+
+... to: nothing
Index: sts/raii/.expect/ctor-autogen-ERR1.txt
===================================================================
--- tests/raii/.expect/ctor-autogen-ERR1.txt	(revision 5c028aca37f98ac589b1636ac6cc0634fc6bf234)
+++ 	(revision )
@@ -1,56 +1,0 @@
-raii/ctor-autogen.cfa:102:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
-  Application of
-    Deleted Expression
-      Variable Expression: ?{}: static inline function
-      ... with parameters
-        _dst: reference to instance of struct Managed with body 1
-        x: signed int
-      ... returning nothing
-
-      ... deleted by: ?{}: function
-      ... with parameters
-        m: reference to instance of struct Managed with body 1
-      ... returning nothing
-      ... with body
-        CompoundStmt
-          Expression Statement:
-            Application of
-              Variable Expression: ?=?: function
-              ... with parameters
-                intrinsic reference to signed int
-                intrinsic signed int
-              ... returning
-                _retval__operator_assign: signed int
-                ... with attributes:
-                  Attribute with name: unused
-
-
-            ... to arguments
-              Generated Cast of:
-                Member Expression, with field:
-                  x: signed int
-                ... from aggregate:
-                  Generated Cast of:
-                    Variable Expression: m: reference to instance of struct Managed with body 1
-                  ... to:
-                    instance of struct Managed with body 1
-              ... to:
-                reference to signed int
-              Generated Cast of:
-                constant expression (0 0: zero_t)
-              ... to:
-                signed int
-
-            ... with environment:
-              Types:
-              Non-types:
-
-
-  ... to arguments
-    Generated Cast of:
-      Variable Expression: x: instance of struct Managed with body 1
-    ... to:
-      reference to instance of struct Managed with body 1
-    constant expression (123 123: signed int)
-
-... to: nothing